#include "Truel.h"

Truel::Truel(){
	temp = 1;
	color = GetColor(255, 255, 255);
	focusFlag = false;
	cursor_x = cursor_y = 0;
	default();
	for (int i = 0; i < 8; i++)resultCount[i] = 0;
}

void Truel::default(){
	for (int x = 0; x < 3; x++){
		settingData[ACC][x] = 100;
		settingData[STR][x] = 0;
		settingData[BUL][x] = -1;
		settingData[SPD][x] = 1;
	}
	settingData[TIMING][0] = 0;
	settingData[FINISH][0] = 0;
	settingData[TRIAL][0] = 10000;
}

void Truel::truelMain(){
	printSetting();
	input();
}

void Truel::printSetting(){
	if (focusFlag == false){
		if (cursor_y < TIMING)DrawBox((cursor_x + 1) * 160, (cursor_y + 1) * 20, (cursor_x + 2) * 160, (cursor_y + 2) * 20, GetColor(255, 0, 0), false);
		else if (cursor_y < BLANK)DrawBox(160, (cursor_y + 1) * 20, 320, (cursor_y + 2) * 20, GetColor(255, 0, 0), false);
		else DrawBox(0, (cursor_y + 1) * 20, 160, (cursor_y + 2) * 20, GetColor(255, 0, 0), false);
	}
	else {
		if (cursor_y < TIMING)DrawBox((cursor_x + 1) * 160, (cursor_y + 1) * 20, (cursor_x + 2) * 160, (cursor_y + 2) * 20, GetColor(255, 0, 0), true);
		else if (cursor_y < BLANK)DrawBox(160, (cursor_y + 1) * 20, 320, (cursor_y + 2) * 20, GetColor(255, 0, 0), true);
	}

	DrawString(160, 0, "vC[A", color);
	DrawString(320, 0, "vC[B", color);
	DrawString(480, 0, "vC[C", color);
	DrawString(0, 20, "", color);
	DrawString(0, 40, "헪", color);
	DrawString(0, 60, "e", color);
	DrawString(0, 80, "AˊԊu", color);
	DrawString(0, 100, "C", color);
	DrawString(0, 120, "`", color);
	DrawString(0, 140, "s", color);
	DrawString(0, 180, "ݒɖ߂", color);
	DrawString(0, 200, "Jn", color);
	DrawString(0, 260, "ʁ", color);
	DrawString(0, 280, "A", color);
	DrawString(80, 280, "B", color);
	DrawString(160, 280, "C", color);
	DrawString(240, 280, "AB", color);
	DrawString(320, 280, "BC", color);
	DrawString(400, 280, "AC", color);
	DrawString(480, 280, "ABC", color);
	DrawString(560, 280, "Ȃ", color);
	DrawFormatString(0, 300, color, "%d", resultCount[1]);
	DrawFormatString(80, 300, color, "%d", resultCount[2]);
	DrawFormatString(160, 300, color, "%d", resultCount[4]);
	DrawFormatString(240, 300, color, "%d", resultCount[3]);
	DrawFormatString(320, 300, color, "%d", resultCount[6]);
	DrawFormatString(400, 300, color, "%d", resultCount[5]);
	DrawFormatString(480, 300, color, "%d", resultCount[7]);
	DrawFormatString(560, 300, color, "%d", resultCount[0]);
	DrawFormatString(0, 320, color, "%.2f%%", resultCount[1] * 100.0 / temp);
	DrawFormatString(80, 320, color, "%.2f%%", resultCount[2] * 100.0 / temp);
	DrawFormatString(160, 320, color, "%.2f%%", resultCount[4] * 100.0 / temp);
	DrawFormatString(240, 320, color, "%.2f%%", resultCount[3] * 100.0 / temp);
	DrawFormatString(320, 320, color, "%.2f%%", resultCount[6] * 100.0 / temp);
	DrawFormatString(400, 320, color, "%.2f%%", resultCount[5] * 100.0 / temp);
	DrawFormatString(480, 320, color, "%.2f%%", resultCount[7] * 100.0 / temp);
	DrawFormatString(560, 320, color, "%.2f%%", resultCount[0] * 100.0 / temp);
	DrawString(0, 340, "vC[ʐʁ", color);
	DrawString(0, 360, "A", color);
	DrawString(160, 360, "B", color);
	DrawString(320, 360, "C", color);
	DrawFormatString(0, 380, color, "%d", resultCount[1] + resultCount[3] + resultCount[5] + resultCount[7]);
	DrawFormatString(160, 380, color, "%d", resultCount[2] + resultCount[3] + resultCount[6] + resultCount[7]);
	DrawFormatString(320, 380, color, "%d", resultCount[4] + resultCount[5] + resultCount[6] + resultCount[7]);
	DrawFormatString(0, 400, color, "%.2f%%", (resultCount[1] + resultCount[3] + resultCount[5] + resultCount[7]) * 100.0 / temp);
	DrawFormatString(160, 400, color, "%.2f%%", (resultCount[2] + resultCount[3] + resultCount[6] + resultCount[7])  * 100.0 / temp);
	DrawFormatString(320, 400, color, "%.2f%%", (resultCount[4] + resultCount[5] + resultCount[6] + resultCount[7])  * 100.0 / temp);

	for (int y = 0; y < 7; y++){
		if (y != BLANK){
			for (int x = 0; x < 3; x++){
				switch (y){
				case ACC:
					DrawFormatString(160 * (x + 1), 20 * (y + 1), color, "%d%%", settingData[y][x]);
					break;
				case STR:
					if (settingData[y][x] == BEST)DrawString(160 * (x + 1), 20 * (y + 1), "ŋ_", color);
					if (settingData[y][x] == WORST)DrawString(160 * (x + 1), 20 * (y + 1), "Ŏ_", color);
					if (settingData[y][x] == MOST)DrawString(160 * (x + 1), 20 * (y + 1), "eő_", color);
					if (settingData[y][x] == LEAST)DrawString(160 * (x + 1), 20 * (y + 1), "eŏ_", color);
					if (settingData[y][x] == RANDOMNORMAL)DrawString(160 * (x + 1), 20 * (y + 1), "_iʁj", color);
					if (settingData[y][x] == RANDOMSKY)DrawString(160 * (x + 1), 20 * (y + 1), "_iCLj", color);
					if (settingData[y][x] == RANDOMNOSHOT)DrawString(160 * (x + 1), 20 * (y + 1), "_isLj", color);
					break;
				case BUL:
					if (settingData[y][x] == -1) DrawString(160 * (x + 1), 20 * (y + 1), "", color);
					if (settingData[y][x] != -1)DrawFormatString(160 * (x + 1), 20 * (y + 1), color, "%d", settingData[y][x]);
					break;
				case SPD:
					DrawFormatString(160 * (x + 1), 20 * (y + 1), color, "%d%", settingData[y][x]);
					break;
				case TIMING:
					if (x == 0){
						if (settingData[y][x] == FIXEDORDER)DrawString(160 * (x + 1), 20 * (y + 1), "ԁiABCcj", color);
						if (settingData[y][x] == RANDOMORDER)DrawString(160 * (x + 1), 20 * (y + 1), "_Ɉl", color);
						if (settingData[y][x] == SIMULTANEOUS)DrawString(160 * (x + 1), 20 * (y + 1), "S", color);
						if (settingData[y][x] == SPEED)DrawString(160 * (x + 1), 20 * (y + 1), "", color);
					}
					break;
				case FINISH:
					if (x == 0){
						if (settingData[y][x] == ONCE)DrawString(160 * (x + 1), 20 * (y + 1), "x", color);
						if (settingData[y][x] == LAST)DrawString(160 * (x + 1), 20 * (y + 1), "Ō܂", color);
					}
					break;
				case TRIAL:
					if (x == 0)DrawFormatString(160 * (x + 1), 20 * (y + 1), color, "%d", settingData[y][x]);
					break;
				default:
					break;
				}
			}
		}
	}

	DrawString(0, 460, "iL[Fړ@EnterL[FIE@SpaceL[FJnj", color);
}

void Truel::input(){
	if (keyInputLong(KEY_INPUT_LEFT) == true){
		if (focusFlag == false){
			switch (cursor_y){
			case ACC: case STR: case BUL: case SPD:
				if (cursor_x > 0)cursor_x--;
			default:
				break;
			}
		}
		else{
			switch (cursor_y){
			case ACC:
				if (settingData[cursor_y][cursor_x] > 0)settingData[cursor_y][cursor_x]--;
				break;
			case STR:
				if (settingData[cursor_y][cursor_x] > 0)settingData[cursor_y][cursor_x]--;
				break;
			case BUL:
				if (settingData[cursor_y][cursor_x] > -1)settingData[cursor_y][cursor_x]--;
				break;
			case SPD:
				if (settingData[cursor_y][cursor_x] > 1)settingData[cursor_y][cursor_x]--;
				break;
			case TIMING:
				if (settingData[cursor_y][0] > 0)settingData[cursor_y][0]--;
				break;
			case FINISH:
				if (settingData[cursor_y][0] > 0)settingData[cursor_y][0]--;
				break;
			case TRIAL:
				if (settingData[cursor_y][0] > 0)settingData[cursor_y][0] -= (int)pow(10, (int)log10(settingData[cursor_y][0] - 1));
				break;
			default:
				break;
			}
		}
	}

	if (keyInputLong(KEY_INPUT_RIGHT) == true){
		if (focusFlag == false){
			switch (cursor_y){
			case ACC: case STR: case BUL: case SPD:
				if (cursor_x < 2)cursor_x++;
			default:
				break;
			}
		}
		else{
			switch (cursor_y){
			case ACC:
				if (settingData[cursor_y][cursor_x] < 100)settingData[cursor_y][cursor_x]++;
				break;
			case STR:
				if (settingData[cursor_y][cursor_x] < RANDOMNOSHOT)settingData[cursor_y][cursor_x]++;
				break;
			case BUL:
				settingData[cursor_y][cursor_x]++;
				break;
			case SPD:
				settingData[cursor_y][cursor_x]++;
				break;
			case TIMING:
				if (settingData[cursor_y][0] < SPEED)settingData[cursor_y][0]++;
				break;
			case FINISH:
				if (settingData[cursor_y][0] < LAST)settingData[cursor_y][0]++;
				break;
			case TRIAL:
				if (settingData[cursor_y][0] < 100000000)settingData[cursor_y][0] += (int)pow(10, (int)log10(settingData[cursor_y][0]));
				break;
			default:
				break;
			}
		}
	}

	if (keyInputLong(KEY_INPUT_UP) == true && focusFlag == false){
		switch (cursor_y){
		case STR: case BUL: case SPD: case TIMING: case FINISH: case TRIAL: case START:
			cursor_y--;
			break;
		 case DEFAULT:
			cursor_y -= 2;
			break;
		default:
			break;
		}
	}

	if (keyInputLong(KEY_INPUT_DOWN) == true && focusFlag == false){
		switch (cursor_y){
		case ACC: case STR: case BUL: case SPD: case TIMING: case FINISH: case DEFAULT:
			cursor_y++;
			break;
		case TRIAL:
			cursor_y += 2;
			break;
		default:
			break;
		}
	}

	if (keyInputShort(KEY_INPUT_RETURN) == true || keyInputShort(KEY_INPUT_Z) == true){
		switch (cursor_y){
		case ACC: case STR: case BUL: case SPD: case TIMING: case FINISH: case TRIAL:
			if (focusFlag == false)focusFlag = true;
			else focusFlag = false;
			break;
		case DEFAULT:
			default();
			break;
		case START:
			simulation();
			break;
		default:
			break;
		}
	}

	if (keyInputShort(KEY_INPUT_SPACE) == true){
		simulation();
	}
}

void Truel::simulation(){
	//reset resultCount
	for (int i = 0; i < 8; i++)resultCount[i] = 0;

	for (int i = 0; i < settingData[TRIAL][0]; i++){
		//reset status
		for (int j = 0; j < 3; j++){
			status[j][LIVE] = 1;
			status[j][RESTBUL] = settingData[BUL][j];
		}
		//reset turn and time
		turn = -1;
		time = 0;

		while (1){
			//special case
			if ((status[0][LIVE] == 0 || status[0][RESTBUL] == 0 || settingData[ACC][0] == 0) &&
				(status[1][LIVE] == 0 || status[1][RESTBUL] == 0 || settingData[ACC][1] == 0) &&
				(status[2][LIVE] == 0 || status[2][RESTBUL] == 0 || settingData[ACC][2] == 0)){
				break;
			}

			if (settingData[TIMING][0] == SIMULTANEOUS){
				for (int j = 0; j < 3; j++) {
					if (status[j][LIVE] == 1 && status[j][RESTBUL] != 0)decideTarget(j);
					else status[j][TARGET] = SKY;
				}
				for (int j = 0; j < 3; j++)fire(j);
			}

			else if (settingData[TIMING][0] == SPEED){
				time++;
				for (int j = 0; j < 3; j++) {
					if (time % settingData[SPD][j] == 0){
						if (status[j][LIVE] == 1 && status[j][RESTBUL] != 0)decideTarget(j);
						else status[j][TARGET] = SKY;
					}
				}
				for (int j = 0; j < 3; j++){
					if (time % settingData[SPD][j] == 0){
						fire(j);
					}
				}
			}

			else{//timing -> order
				//decide turn
				if (settingData[TIMING][0] == FIXEDORDER){
					while (1){
						turn = (turn + 1) % 3;
						if (status[turn][LIVE] == 1 && status[turn][RESTBUL] != 0)break;
					}
				}
				if (settingData[TIMING][0] == RANDOMORDER){
					while (1){
						turn = GetRand(2);
						if (status[turn][LIVE] == 1 && status[turn][RESTBUL] != 0)break;
					}
				}

				//decide target
				decideTarget(turn);

				//fire
				fire(turn);
			}

			//special case
			if ((settingData[TIMING][0] != SPEED || time >= min(min(settingData[SPD][0], settingData[SPD][1]), settingData[SPD][2])) && 
				settingData[FINISH][0] == ONCE)break;
			if (status[0][LIVE] + status[1][LIVE] + status[2][LIVE] <= 1)break;
		}

		//count result
		temp = 0;
		if (status[0][LIVE] == 1)temp += 1;
		if (status[1][LIVE] == 1)temp += 2;
		if (status[2][LIVE] == 1)temp += 4;
		resultCount[temp]++;
	}

	temp = settingData[TRIAL][0];
}

void Truel::decideTarget(int player){
	target = -1;
	//temp = 0;
	if (settingData[STR][player] == BEST){
		for (int i = 0; i < 3; i++){
			if (i != player && status[i][LIVE] == 1){
				if (target == -1){
					temp = settingData[ACC][i];
					target = i;
				}
				else {//target != -1, 2nd person
					if (settingData[ACC][i] == temp) target = -1;//target reset
					else if (settingData[ACC][i] > temp) target = i;
				}
			}
		}
	}
	if (settingData[STR][player] == WORST){
		for (int i = 0; i < 3; i++){
			if (i != player && status[i][LIVE] == 1){
				if (target == -1){
					temp = settingData[ACC][i];
					target = i;
				}
				else {
					if (settingData[ACC][i] == temp) target = -1;
					else if (settingData[ACC][i] < temp) target = i;
				}
			}
		}
	}
	if (settingData[STR][player] == MOST){
		for (int i = 0; i < 3; i++){
			if (i != player && status[i][LIVE] == 1){
				if (target == -1){
					temp = status[i][RESTBUL];
					target = i;
				}
				else {
					if (status[i][RESTBUL] == temp) target = -1;
					else if (status[i][RESTBUL] > temp || status[i][RESTBUL] == -1) target = i;
				}
			}
		}
	}
	if (settingData[STR][player] == LEAST){
		for (int i = 0; i < 3; i++){
			if (i != player && status[i][LIVE] == 1){
				if (target == -1){
					temp = status[i][RESTBUL];
					target = i;
				}
				else {
					if (status[i][RESTBUL] == temp) target = -1;
					else if (status[i][RESTBUL] < temp && status[i][RESTBUL] != -1) target = i;
				}
			}
		}
	}
	if (settingData[STR][player] == RANDOMNORMAL || target == -1){
		while (1){
			target = GetRand(2);
			if (target != player && status[target][LIVE] == 1)break;
		}
	}
	if (settingData[STR][player] == RANDOMSKY){
		while (1){
			target = GetRand(3);
			if (target == SKY || (target != player && status[target][LIVE] == 1))break;
		}
	}
	if (settingData[STR][player] == RANDOMNOSHOT){
		while (1){
			target = GetRand(3);
			if (target == SKY || (target != player && status[target][LIVE] == 1))break;
		}
		if (status[player][RESTBUL] > 0 && target == SKY)status[player][RESTBUL]++;
	}

	//success or fail check
	if (settingData[ACC][player] <= GetRand(99)){
		target = SKY;//failed
	}

	status[player][TARGET] = target;
}

void Truel::fire(int player){
	if (status[player][TARGET] != SKY && status[player][RESTBUL] != 0)status[status[player][TARGET]][LIVE] = 0;
	if (status[player][RESTBUL] > 0)status[player][RESTBUL]--;
}